diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
index de5580cf7..f522a14d3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
@@ -5,6 +5,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
@@ -15,7 +16,7 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
     int @NotNull [] distance;
     public final @NotNull Block<?> blockStill;
 
-	public BlockLogicFluidFlowing(@NotNull Block<?> block, @NotNull Material material, final @NotNull Fluid fluid, @NotNull Block<?> blockStill) {
+    public BlockLogicFluidFlowing(@NotNull Block<?> block, @NotNull Material material, final @NotNull Fluid fluid, @NotNull Block<?> blockStill) {
         super(block, material, fluid);
         this.maxCount = 0;
         this.result = new boolean[4];
@@ -23,58 +24,49 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
         this.blockStill = blockStill;
     }
 
-    private void setFluidStill(@NotNull World world, @NotNull TilePos tilePos) {
+    private void setFluidStill(@NotNull World world, @NotNull TilePosc tilePos) {
         world.setBlockIdData(tilePos, this.blockStill.id(), world.getBlockData(tilePos));
         world.markBlocksDirty(tilePos, tilePos);
         world.markBlockNeedsUpdate(tilePos);
     }
 
     @Override
-    public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick)
-    {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         int localFlowDecay = getDepth(world, tilePos);
         final byte flowDecayMod = this.fluid.getFlowDecayMod(this, world, tilePos);
 
-        TilePos down = tilePos.down();
-        TilePos up = tilePos.up();
-        TilePos north = tilePos.north();
-        TilePos south = tilePos.south();
-        TilePos west = tilePos.west();
-        TilePos east = tilePos.east();
+        TilePos queryPos = new TilePos();
 
-        if(localFlowDecay > 0) {
+        if (localFlowDecay > 0) {
             int surroundingFlowDecay = -100;
             this.maxCount = 0;
-            surroundingFlowDecay = getHighest(world, west, surroundingFlowDecay);
-            surroundingFlowDecay = getHighest(world, east, surroundingFlowDecay);
-            surroundingFlowDecay = getHighest(world, north, surroundingFlowDecay);
-            surroundingFlowDecay = getHighest(world, south, surroundingFlowDecay);
+            surroundingFlowDecay = getHighest(world, tilePos.west(queryPos), surroundingFlowDecay);
+            surroundingFlowDecay = getHighest(world, tilePos.east(queryPos), surroundingFlowDecay);
+            surroundingFlowDecay = getHighest(world, tilePos.north(queryPos), surroundingFlowDecay);
+            surroundingFlowDecay = getHighest(world, tilePos.south(queryPos), surroundingFlowDecay);
             int newFlowDecay = surroundingFlowDecay + flowDecayMod;
-            if(newFlowDecay >= 8 || surroundingFlowDecay < 0) {
+            if (newFlowDecay >= 8 || surroundingFlowDecay < 0) {
                 newFlowDecay = -1;
             }
-            if(getDepth(world, up) >= 0) {
-                int flowDecayAbove = getDepth(world, up);
-                if(flowDecayAbove >= 8)
-                {
+            if (getDepth(world, tilePos.up(queryPos)) >= 0) {
+                int flowDecayAbove = getDepth(world, tilePos.up(queryPos));
+                if (flowDecayAbove >= 8) {
                     newFlowDecay = flowDecayAbove;
-                } else
-                {
+                } else {
                     newFlowDecay = flowDecayAbove + 8;
                 }
             }
             // Become source block
-            if(this.maxCount >= 2 && this.fluid.canBecomeSource(this, world, tilePos, rand)) {
-                if(world.getBlockMaterial(down).isSolid()) {
+            if (this.maxCount >= 2 && this.fluid.canBecomeSource(this, world, tilePos, rand)) {
+                if (world.getBlockMaterial(tilePos.down(queryPos)).isSolid()) {
                     newFlowDecay = 0;
-                }
-                else if(world.getBlockMaterial(down) == this.material && world.getBlockData(down) == 0) {
+                } else if (world.getBlockMaterial(tilePos.down(queryPos)) == this.material && world.getBlockData(tilePos.down(queryPos)) == 0) {
                     newFlowDecay = 0;
                 }
             }
-            if(newFlowDecay != localFlowDecay) {
+            if (newFlowDecay != localFlowDecay) {
                 localFlowDecay = newFlowDecay;
-                if(localFlowDecay < 0) {
+                if (localFlowDecay < 0) {
                     world.setBlockIdNotify(tilePos, 0);
                 } else {
                     world.setBlockDataNotify(tilePos, localFlowDecay);
@@ -87,80 +79,78 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
         } else {
             setFluidStill(world, tilePos);
         }
-        if(canSpreadTo(world, down)) {
-        	Block<?> b = world.getBlock(down);
-        	if(b != null) {
-                b.dropWithCause(world, EnumDropCause.WORLD, down, world.getBlockData(down), null, null);
-        	}
-            if(localFlowDecay >= 8) {
-                world.setBlockIdDataNotify(down, this.block.id(), localFlowDecay);
+        if (canSpreadTo(world, tilePos.down(queryPos))) {
+            Block<?> b = world.getBlock(tilePos.down(queryPos));
+            if (b != null) {
+                b.dropWithCause(world, EnumDropCause.WORLD, tilePos.down(queryPos), world.getBlockData(tilePos.down(queryPos)), null, null);
+            }
+            if (localFlowDecay >= 8) {
+                world.setBlockIdDataNotify(tilePos.down(queryPos), this.block.id(), localFlowDecay);
             } else {
-                world.setBlockIdDataNotify(down, this.block.id(), localFlowDecay + 8);
+                world.setBlockIdDataNotify(tilePos.down(queryPos), this.block.id(), localFlowDecay + 8);
             }
-        } else if(localFlowDecay >= 0 && (localFlowDecay == 0 || isFluidBlocking(world, down))) {
+        } else if (localFlowDecay >= 0 && (localFlowDecay == 0 || isFluidBlocking(world, tilePos.down(queryPos)))) {
             boolean[] spreadFlags = getSpread(world, tilePos);
             int k1 = localFlowDecay + flowDecayMod;
-            if(localFlowDecay >= 8) {
+            if (localFlowDecay >= 8) {
                 k1 = 1;
             }
-            if(k1 >= 8) {
+            if (k1 >= 8) {
                 return;
             }
-            if(spreadFlags[0]) {
-                flowIntoBlock(world, west, k1);
+            if (spreadFlags[0]) {
+                flowIntoBlock(world, tilePos.west(queryPos), k1);
             }
-            if(spreadFlags[1]) {
-                flowIntoBlock(world, east, k1);
+            if (spreadFlags[1]) {
+                flowIntoBlock(world, tilePos.east(queryPos), k1);
             }
-            if(spreadFlags[2]) {
-                flowIntoBlock(world, north, k1);
+            if (spreadFlags[2]) {
+                flowIntoBlock(world, tilePos.north(queryPos), k1);
             }
-            if(spreadFlags[3]) {
-                flowIntoBlock(world, south, k1);
+            if (spreadFlags[3]) {
+                flowIntoBlock(world, tilePos.south(queryPos), k1);
             }
         }
     }
 
     private void flowIntoBlock(@NotNull World world, @NotNull TilePos tilePos, int meta) {
-        if(canSpreadTo(world, tilePos)) {
+        if (canSpreadTo(world, tilePos)) {
             int id = world.getBlockId(tilePos);
-            if(id > 0) {
+            if (id > 0) {
                 this.fluid.onFlowIntoBlock(this, world, tilePos, meta);
             }
             world.setBlockIdDataNotify(tilePos, this.block.id(), meta);
         }
     }
 
-    private int getSlopeDistance(@NotNull World world, @NotNull TilePos tilePos, int l, int i1) {
+    private int getSlopeDistance(@NotNull World world, @NotNull TilePosc tilePos, int l, int i1) {
         int j1 = 1000;
-        TilePos p = new TilePos(tilePos);
-        for(int d = 0; d < 4; d++) {
-            if(d == 0 && i1 == 1 || d == 1 && i1 == 0 || d == 2 && i1 == 3 || d == 3 && i1 == 2)
-            {
+        TilePos queryPos = new TilePos(tilePos);
+        for (int d = 0; d < 4; d++) {
+            if (d == 0 && i1 == 1 || d == 1 && i1 == 0 || d == 2 && i1 == 3 || d == 3 && i1 == 2) {
                 continue;
             }
-            p.set(tilePos.x, tilePos.y, tilePos.z);
+            int checkX = tilePos.x();
+            int checkY = tilePos.y();
+            int checkZ = tilePos.z();
             switch (d) {
-                case 0 -> p.x--;
-                case 1 -> p.x++;
-                case 2 -> p.z--;
-                case 3 -> p.z++;
+                case 0 -> checkX--;
+                case 1 -> checkX++;
+                case 2 -> checkZ--;
+                case 3 -> checkZ++;
             }
-            if(isFluidBlocking(world, p) || world.getBlockMaterial(p) == this.material && world.getBlockData(p) == 0)
-            {
+            queryPos.set(checkX, checkY, checkZ);
+            if (isFluidBlocking(world, queryPos) || world.getBlockMaterial(queryPos) == this.material && world.getBlockData(queryPos) == 0) {
                 continue;
             }
-            if(!isFluidBlocking(world, p.down()))
-            {
+            if (!isFluidBlocking(world, queryPos.set(checkX, checkY - 1, checkZ))) {
                 return l;
             }
-            if(l >= 4)
-            {
+            if (l >= 4) {
                 continue;
             }
-            int k2 = getSlopeDistance(world, p, l + 1, d);
-            if(k2 < j1)
-            {
+            int k2 = getSlopeDistance(world, queryPos.set(checkX, checkY, checkZ), l + 1, d);
+            if (k2 < j1) {
                 j1 = k2;
             }
         }
@@ -168,35 +158,38 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
         return j1;
     }
 
-    private boolean[] getSpread(@NotNull World world, @NotNull TilePos tilePos) {
-        TilePos p = new TilePos(tilePos);
-        for(int d = 0; d < 4; d++) {
+    private boolean[] getSpread(@NotNull World world, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos(tilePos);
+        for (int d = 0; d < 4; d++) {
             this.distance[d] = 1000;
-            p.set(tilePos.x, tilePos.y, tilePos.z);
+            int checkX = tilePos.x();
+            int checkY = tilePos.y();
+            int checkZ = tilePos.z();
             switch (d) {
-                case 0 -> p.x--;
-                case 1 -> p.x++;
-                case 2 -> p.z--;
-                case 3 -> p.z++;
+                case 0 -> checkX--;
+                case 1 -> checkX++;
+                case 2 -> checkZ--;
+                case 3 -> checkZ++;
             }
-            if(isFluidBlocking(world, p) || world.getBlockMaterial(p) == this.material && world.getBlockData(p) == 0) {
+            queryPos.set(checkX, checkY, checkZ);
+            if (isFluidBlocking(world, queryPos) || world.getBlockMaterial(queryPos) == this.material && world.getBlockData(queryPos) == 0) {
                 continue;
             }
-            if(!isFluidBlocking(world, p.down())) {
+            if (!isFluidBlocking(world, queryPos.set(checkX, checkY - 1, checkZ))) {
                 this.distance[d] = 0;
             } else {
-                this.distance[d] = getSlopeDistance(world, p, 1, d);
+                this.distance[d] = getSlopeDistance(world, queryPos.set(checkX, checkY, checkZ), 1, d);
             }
         }
 
         int i1 = this.distance[0];
-        for(int k1 = 1; k1 < 4; k1++) {
-            if(this.distance[k1] < i1) {
+        for (int k1 = 1; k1 < 4; k1++) {
+            if (this.distance[k1] < i1) {
                 i1 = this.distance[k1];
             }
         }
 
-        for(int l1 = 0; l1 < 4; l1++) {
+        for (int l1 = 0; l1 < 4; l1++) {
             this.result[l1] = this.distance[l1] == i1;
         }
 
@@ -210,13 +203,13 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
 
     protected int getHighest(@NotNull World world, @NotNull TilePos tilePos, int currentFlowDecay) {
         int flowDecay = getDepth(world, tilePos);
-        if(flowDecay < 0) {
+        if (flowDecay < 0) {
             return currentFlowDecay;
         }
-        if(flowDecay == 0) {
+        if (flowDecay == 0) {
             this.maxCount++;
         }
-        if(flowDecay >= 8) {
+        if (flowDecay >= 8) {
             flowDecay = 0;
         }
         return currentFlowDecay >= 0 && flowDecay >= currentFlowDecay ? currentFlowDecay : flowDecay;
@@ -224,10 +217,10 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
 
     private boolean canSpreadTo(@NotNull World world, @NotNull TilePos tilePos) {
         Material material = world.getBlockMaterial(tilePos);
-        if(material == this.material) {
+        if (material == this.material) {
             return false;
         }
-        if(!this.fluid.canSpreadTo(this, world, tilePos, material)) {
+        if (!this.fluid.canSpreadTo(this, world, tilePos, material)) {
             return false;
         } else {
             return !isFluidBlocking(world, tilePos);
@@ -235,9 +228,9 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
     }
 
     @Override
-    public void onPlacedByWorld(@NotNull World world, @NotNull TilePos tilePos) {
+    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         super.onPlacedByWorld(world, tilePos);
-        if(world.getBlockId(tilePos) == this.block.id()) {
+        if (world.getBlockId(tilePos) == this.block.id()) {
             world.scheduleBlockUpdate(tilePos, this.block.id(), tickDelay());
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java
index 4c62b0f3d..558e50a88 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java
@@ -5,31 +5,28 @@ import java.util.Random;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
-public class BlockLogicFluidStill extends BlockLogicFluid
-{
+public class BlockLogicFluidStill extends BlockLogicFluid {
     public final @NotNull Block<?> blockFlowing;
 
-	public BlockLogicFluidStill(@NotNull Block<?> block, @NotNull Material material, final @NotNull Fluid fluid, @NotNull Block<?> blockFlowing)
-    {
+    public BlockLogicFluidStill(@NotNull Block<?> block, @NotNull Material material, final @NotNull Fluid fluid, @NotNull Block<?> blockFlowing) {
         super(block, material, fluid);
         block.setTicking(this.fluid.shouldTick());
         this.blockFlowing = blockFlowing;
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         super.onNeighborChanged(world, tilePos, id);
         if (id == Side.TOP.getId()) return;
-        if(world.getBlockId(tilePos) == this.block.id()) {
+        if (world.getBlockId(tilePos) == this.block.id()) {
             setFlowing(world, tilePos);
         }
     }
 
-    private void setFlowing(@NotNull World world, @NotNull TilePos tilePos)
-    {
+    private void setFlowing(@NotNull World world, @NotNull TilePosc tilePos) {
         int meta = world.getBlockData(tilePos);
         world.noNeighborUpdate = true;
         world.setBlockIdData(tilePos, this.blockFlowing.id(), meta);
@@ -39,8 +36,7 @@ public class BlockLogicFluidStill extends BlockLogicFluid
     }
 
     @Override
-	public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick)
-    {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         this.fluid.updateTickStill(this, world, tilePos, rand);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFullyRotatable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFullyRotatable.java
index eea79f2a8..3d67c7024 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFullyRotatable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFullyRotatable.java
@@ -5,7 +5,7 @@ import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicFullyRotatable extends BlockLogic {
@@ -15,13 +15,13 @@ public class BlockLogicFullyRotatable extends BlockLogic {
     }
 
     @Override
-    public void onPlacedByMob(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
+    public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
         final Direction direction = mob.getPlacementDirection(side).getOpposite();
         world.setBlockDataNotify(tilePos, directionToMeta(direction));
     }
 
     @Override
-    public void onPlacedOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         world.setBlockDataNotify(tilePos, directionToMeta(side.getDirection()));
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java
index b82b5c2f0..3de77f003 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java
@@ -4,29 +4,28 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityFurnace;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 import java.util.Random;
 
-public class BlockLogicFurnace extends BlockLogicRotatable
-{
+public class BlockLogicFurnace extends BlockLogicRotatable {
     private static final Logger LOGGER = LogUtils.getLogger();
     public static boolean keepFurnaceInventory = false;
 
     protected final boolean isActive;
 
-	public BlockLogicFurnace(Block<?> block, boolean active)
-    {
-        super(block, Material.stone);
+    public BlockLogicFurnace(Block<?> block, boolean active) {
+        super(block, Materials.STONE);
         this.isActive = active;
         block.withEntity(TileEntityFurnace::new);
     }
@@ -34,20 +33,20 @@ public class BlockLogicFurnace extends BlockLogicRotatable
     @Override
     public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
         return switch (dropCause) {
-            case PICK_BLOCK, EXPLOSION, PROPER_TOOL, SILK_TOUCH, PISTON_CRUSH -> new ItemStack[]{new ItemStack(Blocks.FURNACE_STONE_IDLE)};
+            case PICK_BLOCK, EXPLOSION, PROPER_TOOL, SILK_TOUCH, PISTON_CRUSH ->
+                new ItemStack[]{new ItemStack(Blocks.FURNACE_STONE_IDLE)};
             default -> null;
         };
     }
 
     @Override
-	public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand) {
-        if(!this.isActive)
-        {
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
+        if (!this.isActive) {
             return;
         }
-        double poxX = (double) tilePos.x + 0.5F;
-        double posY = (double) tilePos.y + 0.0F + (rand.nextFloat() * 6F) / 16F;
-        double posZ = (double) tilePos.z + 0.5F;
+        double poxX = (double) tilePos.x() + 0.5F;
+        double posY = (double) tilePos.y() + 0.0F + (rand.nextFloat() * 6F) / 16F;
+        double posZ = (double) tilePos.z() + 0.5F;
         double f3 = 0.52F;
         double f4 = rand.nextFloat() * 0.6F - 0.3F;
         switch (BlockLogicRotatable.getDirectionFromMeta(world.getBlockData(tilePos))) {
@@ -71,7 +70,7 @@ public class BlockLogicFurnace extends BlockLogicRotatable
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         if (!world.isClientSide && world.getTileEntity(tilePos) instanceof TileEntityFurnace furnace) {
             player.displayFurnaceScreen(furnace);
         }
@@ -79,27 +78,27 @@ public class BlockLogicFurnace extends BlockLogicRotatable
     }
 
     public static void updateFurnaceBlockState(@NotNull World world, @NotNull TilePos tilePos, boolean lit) {
-		int meta = world.getBlockData(tilePos);
-		TileEntity tileEntity = world.getTileEntity(tilePos);
-		if(tileEntity == null) {
-			String msg = "Furnace is missing Tile Entity at " + tilePos + ", block will be removed!";
-			if(Global.BUILD_CHANNEL.isUnstableBuild()) {
-				throw new RuntimeException(msg);
-			}
-			world.setBlockIdNotify(tilePos, 0);
+        int meta = world.getBlockData(tilePos);
+        TileEntity tileEntity = world.getTileEntity(tilePos);
+        if (tileEntity == null) {
+            String msg = "Furnace is missing Tile Entity at " + tilePos + ", block will be removed!";
+            if (Global.BUILD_CHANNEL.isUnstableBuild()) {
+                throw new RuntimeException(msg);
+            }
+            world.setBlockIdNotify(tilePos, 0);
             LOGGER.warn(msg);
-			return;
-		}
-		keepFurnaceInventory = true;
-		if(lit) {
-			world.setBlockIdNotify(tilePos, Blocks.FURNACE_STONE_ACTIVE.id());
-		} else {
-			world.setBlockIdNotify(tilePos, Blocks.FURNACE_STONE_IDLE.id());
-		}
-		keepFurnaceInventory = false;
-		world.setBlockDataNotify(tilePos, meta);
-		tileEntity.validate();
-		world.setTileEntity(tilePos, tileEntity);
-	}
+            return;
+        }
+        keepFurnaceInventory = true;
+        if (lit) {
+            world.setBlockIdNotify(tilePos, Blocks.FURNACE_STONE_ACTIVE.id());
+        } else {
+            world.setBlockIdNotify(tilePos, Blocks.FURNACE_STONE_IDLE.id());
+        }
+        keepFurnaceInventory = false;
+        world.setBlockDataNotify(tilePos, meta);
+        tileEntity.validate();
+        world.setTileEntity(tilePos, tileEntity);
+    }
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java
index 79c33ef1a..692b05482 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java
@@ -4,13 +4,14 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityFurnaceBlast;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
@@ -26,7 +27,7 @@ public class BlockLogicFurnaceBlast extends BlockLogicRotatable
 
     public BlockLogicFurnaceBlast(Block<?> block, boolean active)
     {
-        super(block, Material.metal);
+        super(block, Materials.METAL);
         this.isActive = active;
         block.withEntity(TileEntityFurnaceBlast::new);
     }
@@ -41,14 +42,14 @@ public class BlockLogicFurnaceBlast extends BlockLogicRotatable
     }
 
     @Override
-	public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand)
+	public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand)
     {
         if(!this.isActive) {
             return;
         }
-        double posX = (double) tilePos.x + 0.5D;
-        double posY = (double) tilePos.y + (rand.nextFloat() * 6F) / 16D;
-        double posZ = (double) tilePos.z + 0.5D;
+        double posX = (double) tilePos.x() + 0.5D;
+        double posY = (double) tilePos.y() + (rand.nextFloat() * 6F) / 16D;
+        double posZ = (double) tilePos.z() + 0.5D;
         double f3 = 0.52D;
         float f4 = rand.nextFloat() * 0.6F - 0.3F;
         switch (BlockLogicRotatable.getDirectionFromMeta(world.getBlockData(tilePos))) {
@@ -72,7 +73,7 @@ public class BlockLogicFurnaceBlast extends BlockLogicRotatable
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         if (!world.isClientSide && world.getTileEntity(tilePos) instanceof TileEntityFurnaceBlast furnaceBlast) {
             player.displayBlastFurnaceScreen(furnaceBlast);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGlassTinted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGlassTinted.java
index 1f0fc186e..b75b54631 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGlassTinted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGlassTinted.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -13,7 +13,7 @@ public class BlockLogicGlassTinted extends BlockLogicGlass
 
     public BlockLogicGlassTinted(@NotNull Block<?> block)
     {
-        super(block, Material.glass);
+        super(block, Materials.GLASS);
     }
 
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGlowStone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGlowStone.java
index 59764b22b..c03ba5fbf 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGlowStone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGlowStone.java
@@ -7,7 +7,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -28,7 +28,7 @@ public class BlockLogicGlowStone extends BlockLogic
     }
     
     @Override
-    public float getAmbientOcclusionStrength(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public float getAmbientOcclusionStrength(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
     	return 0.0f;
     }
 }
